## nco 4.0.7

=== bld/Makefile ===
# $Header: /cvsroot/nco/nco/bld/Makefile,v 1.573 2011/02/17 21:21:46 zender Exp $ -*-makefile-*-

# Purpose: GNU Makefile for NCO module nco
# Requires GNU Make---AT&T Make chokes on GNU syntax

# Copyright (C) 1994--2011 Charlie Zender
# License: GNU General Public License (GPL) Version 3
# See http://www.gnu.org/copyleft/gpl.html for full license text

# Quickie test copies:
# scp ~/nco/bld/Makefile dust.ess.uci.edu:nco/bld
# scp ~/nco/bld/Makefile gplogin2.ps.uci.edu:nco/bld
# scp ~/nco/bld/Makefile soot.ess.uci.edu:nco/bld

# Development machines default configuration:
# netCDF4, UDUnits2: ashes, elnino, virga, neige
# netCDF3: sand
# netCDF3, OPeNDAP: soot, esmf
# netCDF3, configure: clay

# Usage (testing):
# make tst                           # Vanilla regression test
# make FL_FMT=netcdf4 tst            # netCDF4 regression test
# make MPI_PRC=3 tst                 # MPI regression test
# make MPI_PRC=3 bm                  # MPI benchmarks
# make THR_NBR=2 tst                 # OpenMP regression test
# make THR_NBR=2 bm                  # OpenMP benchmarks
# make NETCDF4=Y                     # netCDF4 features
# make PNETCDF=Y                     # pnetCDF features
# make ZNETCDF=Y                     # znetCDF features

# Usage (Compilation):
# cd ~/nco/bld;make;cd -             # Default build
# cd ~/nco/bld;make cln bin_cln;cd - # Clean all dependencies for fresh build
# cd ~/nco/bld;make dir all; cd -    # Create target directories then build
# cd ~/nco/bld;make dbg;cd -         # Print make diagnostics
# cd ~/nco/bld;make DAP_OPENDAP=Y;cd - # DAP support via OPeNDAP
# cd ~/nco/bld;make GSL=Y;cd -	     # GSL support
# cd ~/nco/bld;make lib_cln;cd -     # Clean libraries
# cd ~/nco/bld;make MPI=Y;cd -       # MPI support
# cd ~/nco/bld;make MPI_FAKE=Y;cd -  # Spoof MPI support
# cd ~/nco/bld;make OMP=Y;cd -       # OpenMP support
# cd ~/nco/bld;make OPTS=D;cd -      # "Debugging": Enough symbols for debugging
# cd ~/nco/bld;make OPTS=O;cd -      # "Optimize": For production (includes symbols)
# cd ~/nco/bld;make OPTS=R;cd -      # "Regular": No optimization or debugging
# cd ~/nco/bld;make OPTS=X;cd -      # "eXtreme": All debugging switches available
# cd ~/nco/bld;make sys;cd -         # Install in /usr/local (must sudo)
# cd ~/nco/bld;make SZ=Y;cd -	     # Szip support
# cd ~/nco/bld;make UDUNITS=Y;cd -   # UDUnits support
# cd ~/nco/bld;make UDUNITS2=Y;cd -  # UDUnits2 support
# cd ~/nco/bld;make --jobs=4;cd -    # Parallel make
# Normal (Linux) developer systems:
# cd ${HOME}/nco/bld;make cln all ncap2;cd - # New default for most machines
# cd ${HOME}/nco/bld;make OMP=Y CUDA=Y OPTS=D NETCDF4=Y UDUNITS2=Y allinone;cd - # givre
# cd ${HOME}/nco/bld;make OMP=Y OPTS=D NETCDF4=Y UDUNITS2=Y allinone;cd - # givre, neige
# cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=Y allinone;cd - # glace, virga
# mpi-selector --set openmpi_gcc-1.3.3 # Then use /sopt/netcdf/netcdf3-gcc-serial serial libraries
# mpi-selector --set mpich_pgi_1.2.7p1 # After compiling
# cd ${HOME}/nco/bld;ANTLR_ROOT=/sopt/gfortran_g++ CNK=N NETCDF_ROOT=/sopt/gfortran_g++ SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=Y SZ=Y UDUNITS2=N allinone;cd - # greenplanet gcc
# cd ${HOME}/nco/bld;ANTLR=/sopt/ifort_icpc/bin/antlr ANTLR_ROOT=/sopt/ifort_icpc CNK=N SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=Y SZ=Y UDUNITS2=N allinone;cd - # greenplanet intel
# cd ${HOME}/nco/bld;ANTLR=/sopt/pgf90_pgcc/bin/antlr ANTLR_ROOT=/sopt/pgf90_pgcc CNK=N SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N SZ=Y UDUNITS2=N allinone;cd - # greenplanet pgi
# cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=Y allinone;cd - # pbs
# cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=Y allinone;cd - # grele
# cd ${HOME}/nco/bld;make OMP=N DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=N USR_TKN='-DNCO_GSL_MINOR_VERSION=4' allinone;cd - # sand, tephra
# cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=N allinone;cd - # silt, clay
# cd ${HOME}/nco/bld;NETCDF_INC='/usr/include/netcdf-3' NETCDF_LIB='/usr/lib64' make GSL=N OMP=N DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS=N  allinone;cd - # snow
# cd ${HOME}/nco/bld;make OMP=N DAP_OPENDAP=Y OPTS=D NETCDF4=N UDUNITS2=N USR_TKN='-DNEED_NC_INQ_FORMAT' allinone;cd - # snow w/OPeNDAP
# cd ${HOME}/nco/bld;make OPTS=D USR_TKN='-DNEED_NC_INQ_FORMAT' allinone;cd -
# 64-bit ABI on UCI MPC:
# cd ${HOME}/nco/bld;env ANTLR='/software/antlr/bin/antlr' ANTLR_ROOT='/software/antlr' UDUNITS_INC='/software/udunits/include' UDUNITS_LIB='/software/udunits/lib' make --jobs=1 ABI=64 allinone;cd -
# 64-bit ABI on UCI IPCC:
# cd ${HOME}/nco/bld;env ANTLR='/usr/local/pgi/bin/antlr' ANTLR_ROOT='/usr/local/pgi' make --jobs=1 ABI=64 allinone;cd -
# 64-bit ABI netCDF3 on NCAR AIX systems (bluefire):
# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' NETCDF_LIB='/usr/local/lib64/r4i4' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 DAP_OPENDAP=N OPTS=D allinone ABI=64;cd -
# 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' CURL_LIB='/contrib/curl/lib' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' HDF5_ROOT='/contrib/hdf5-1.8.4-patch1_sequential' NETCDF_ROOT='/contrib/netcdf-4.1.1_sequential' SZ_LIB='/contrib/szip/lib' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 NETCDF4=Y OPTS=D SZ=Y allinone ABI=64;cd -
# cd ~/bin/AIX;/usr/local/bin/tar cvzf ~/nco-4.0.6.aix53.tar.gz nc*;scp ~/nco-4.0.6.aix53.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
# Cygwin on Windows Vista systems:
# cd ~/nco/bld;ANTLR='antlr' make --jobs=1 GSL=Y OPTS=D NETCDF4=Y UDUNITS2=Y allinone;cd -
# cd ~/bin/WIN32;tar cvzf ~/nco-4.0.6.win32.cygwin.tar.gz nc* ; scp ~/nco-4.0.6.win32.cygwin.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src

# Top-level tokens defining directory structure
# These tokens may be over-ridden by environment variables or when invoking make, e.g., make DAP_OPENDAP=Y
MY_BLD_DIR := ../bld
ifndef PVM_ARCH
 PVM_ARCH := $(shell ${MY_BLD_DIR}/pvmgetarch)
endif
ifndef MY_BIN_DIR
 MY_BIN_DIR := ../bin
endif
ifndef MY_LIB_DIR
 MY_LIB_DIR := ../lib
endif
ifndef MY_MAN_DIR
 MY_MAN_DIR := ../man
endif
ifndef MY_OBJ_DIR
 MY_OBJ_DIR := ../obj
endif
MY_BM_DIR := ../bm
MY_DAT_DIR := ../data
MY_DBN_DIR := ../debian
MY_DOC_DIR := ../doc
MY_DPN_DIR := ${MY_OBJ_DIR}
MY_SRC_DIR := ../src/nco
MY_INC_DIR := ${MY_SRC_DIR}
NCO_CXX_SRC_DIR := ${MY_SRC_DIR}/../nco_c++
NCOXX_SRC_DIR := ${MY_SRC_DIR}/../nco++

# Primary tokens which determine build options
# Specify non-default when invoking make, e.g. make DAP_OPENDAP=Y
ifndef ${ABI}
# 32- vs. 64-bit ABI: 32=32-bit mode, 64=64-bit mode (default) if available
 ABI := 64
endif # endif ABI
ifndef ${CCACHE}
 CCACHE := N
endif # CCACHE
ifndef CNK
# Use newer netCDF4.1 chunking API
 CNK := Y
endif # endif CNK
ifndef ${CUDA}
 CUDA := N
endif # CUDA
ifndef DAP_NETCDF
 DAP_NETCDF := Y
endif # DAP_NETCDF
ifndef DAP_OPENDAP
 DAP_OPENDAP := N
endif # DAP_OPENDAP
ifndef ${DBG}
# Debugging token N=No (default) Y=Yes
 DBG := N
endif # endif DBG
ifdef FL_FMT
# Pass this netCDF4 argument to nco_bm.pl
 FL_FMT_SNG := "--fl_fmt=${FL_FMT}"
else # endif FL_FMT
 FL_FMT_SNG :=
endif # endif FL_FMT
ifndef GCC_RCH_ARG
 GCC_RCH_ARG :=
endif # endif GCC_RCH_ARG
ifndef GSL
# Use GSL functionality
 GSL := Y
endif # endif GSL
ifndef ICC_RCH_ARG
 ICC_RCH_ARG :=
endif # endif ICC_RCH_ARG
ifndef I18N
 I18N := N
endif
ifndef NCO_YY_PFX
 NCO_YY_PFX := nco_yy
endif
ifndef MK_DPN
 MK_DPN = ${CPP} -M # NB: Recursive expansion required
 MK_DPN_CXX = ${CXX} -M # NB: Recursive expansion required
endif # endif MK_DPN
ifndef ${MPI} # MPI
 MPI := N
endif # endif MPI
ifndef ${MPI_FAKE} # MPI
 MPI_FAKE := N
endif # endif MPI_FAKE
ifndef NCO_VRS
# Used for RPM building
 NCO_VRS := $(shell cat ${MY_DOC_DIR}/VERSION)
endif
ifndef ${NETCDF4} # netCDF4 support
 NETCDF4 := Y
endif # endif NETCDF4
ifndef NETCDF_ROOT
 NETCDF_ROOT := /usr/local
endif
ifndef NETCDF4_ROOT
 NETCDF4_ROOT := ${NETCDF_ROOT}
endif
ifndef NETCDF_INC
 NETCDF_INC := ${NETCDF_ROOT}/include # Directory containing netcdf.h
endif
ifndef NETCDF_LIB
 NETCDF_LIB := ${NETCDF_ROOT}/lib # Directory containing libnetcdf.a
endif
ifndef ${OMP} # OpenMP
 OMP := Y
endif # endif OMP
ifndef OPTS
 OPTS := O
endif
ifndef PGI_RCH_ARG
 PGI_RCH_ARG :=
endif # endif PGI_RCH_ARG
ifndef ${PNETCDF} # pnetCDF support
 PNETCDF := N
endif # endif PNETCDF
ifndef PSC_RCH_ARG
 PSC_RCH_ARG :=
endif # endif PSC_RCH_ARG
ifndef RPM
 RPM := N
endif # endif RPM
ifndef STC
# Created statically linked executable
 STC := N
endif
ifndef SZ
# Link to Szip library
 SZ := N
endif
ifndef UDUNITS
# Use UDUnits functionality
 UDUNITS := N
endif
ifndef UDUNITS2
# Use UDUnits2 functionality
 UDUNITS2 := Y
endif
ifndef UNAMES
 UNAMES := $(shell uname -s)
endif
ifndef USR_TKN
 USR_TKN :=
endif # endif USR_TKN
ifndef VRS_SNG
 VRS_SNG := $(shell date +%Y%m%d)
endif # endif VRS_SNG
ifndef ${ZNETCDF} # znetcdf support
 ZNETCDF := N
endif # endif ZNETCDF
# Derived-tokens based on primary tokens
# These tokens should not be altered by hand

# NB: CPP_TKN is recursively expanded variable, define only when components are ready
CPP_TKN = ${USR_TKN} -D${PVM_ARCH} -DNO_NETCDF_2 -DVERSION='${VRS_SNG}' -DHOSTNAME='${HOST}' -DUSER='${USER}' -DNCO_ABORT_ON_ERROR
ifndef LFLAGS # Flags for Flex (Lex)
 LFLAGS := -P${NCO_YY_PFX}
endif
ifndef YFLAGS # Flags for Bison (Yacc)
 YFLAGS := -d --name-prefix=${NCO_YY_PFX}
endif

# Default NCO build: DAP_NETCDF, DAP_OPENDAP, NETCDF4, PNETCDF, and ZNETCDF clauses may overwrite this
NC_LDFLAGS := -L${NETCDF_LIB}
NC_LIBS := -lnetcdf 

ifeq (${DAP_NETCDF},Y)
# Build NCO as DAP-enabled clients with netCDF-provided DAP
ifndef DAP_NETCDF_ROOT
# Directory containing libcurl.a
 DAP_NETCDF_ROOT := /usr
endif # DAP_NETCDF_ROOT
 NC_LDFLAGS := -L${DAP_NETCDF_ROOT}/lib
# netCDF 4.0.1+:
 NC_LIBS += -lcurl
endif # end DAP_NETCDF
               
ifeq (${DAP_OPENDAP},Y)
# Build NCO as DAP-enabled clients with OPe NDAP
# fxm: OPeNDAP bloats executables, should automagically enable stripping?
# http://www.opendap.org/user/guide-html/guide_28.html
ifndef DAP_OPENDAP_ROOT
# Directory containing libdap.a, libnc-dap.a
 DAP_OPENDAP_ROOT := /usr/local
endif # DAP_OPENDAP_ROOT
 NC_LDFLAGS := -L${DAP_OPENDAP_ROOT}/lib
# NB: nc-dods, dap++ prior to version 3.5.X must be linked twice!
# Required libraries for
# DODS 3.3-:
# NC_LIBS := -lnc-dods -ldap++ -lnc-dods -ldap++ -lwww -lz -lrx
# DODS 3.4.X:
# NC_LIBS := -lnc-dods -ldap++ -lnc-dods -ldap++ -lxml2 -lcurl -lpthread -ldl -lz
# OPeNDAP 3.5.0-3.5.1:
# NC_LIBS := -lnc-dap -ldap++ -lxml2 -lcurl
# OPeNDAP 3.5+:
 NC_LIBS += -lnc-dap -ldap -lxml2 -lcurl
# In addition, AIX OPeNDAP requires these libraries...
ifneq (${null},$(findstring AIX,${PVM_ARCH}))
 NC_LIBS += -lcrypto -liconv -lssl -lz
endif # end AIX
# Get netCDF from OPeNDAP version
 NETCDF_INC=${DAP_OPENDAP_ROOT}/include/libnc-dap
 NETCDF_LIB=${DAP_OPENDAP_ROOT}/lib
endif # end DAP_OPENDAP

# Internationalize NCO with i18n features
ifeq (${I18N},Y)
 MY_SHR_DIR := ${HOME}/share
 MY_ES_DIR := ${MY_SHR_DIR}/locale/es/LC_MESSAGES
 MY_FR_DIR := ${MY_SHR_DIR}/locale/fr/LC_MESSAGES
endif

# Message Passing Interface (MPI)
ifeq (${MPI_FAKE},Y)
# MPI_FAKE instructs make to compile mpnc*.c operators without defining ENABLE_MPI
# Resulting executables use UP or SMP code not MPI code
# This tests compile, link, execution of MPI mpnc*.c code without using any MPI calls
 MPI := Y
endif # !MPI_FAKE
ifdef MPI_PRC

=== debian/changelog ===
nco (4.0.7-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't ship .la files (Closes: #622527).

 -- Luk Claes <luk@debian.org>  Sun, 26 Jun 2011 09:34:27 +0200

nco (4.0.7-1) unstable; urgency=low

  * new upstream version (fix bug_hyp_dgn, srd w/dap)

 -- Charlie Zender <zender@uci.edu>  Fri, 21 Jan 2011 11:30:56 -0700

nco (4.0.6-1) unstable; urgency=low

  * new upstream version (clang, YYYYMMDD-averaging, xtr ass crd)
  * debian/rules
    - build with dap-netcdf netcdf4 udunits2 by default

 -- Charlie Zender <zender@uci.edu>  Fri, 14 Jan 2011 11:30:56 -0700

nco (4.0.5-1) unstable; urgency=low

  * new upstream version (fix ncks hyp NC4 bug, ncra CF crd bug)
  * debian/control
    - require libudunits2-0, libudunits2-dev
  * debian/rules
    - build with DEB_BUILD_OPTIONS='dap-netcdf netcdf4 udunits2'

 -- Charlie Zender <zender@uci.edu>  Thu, 13 Oct 2010 11:30:56 -0700

nco (4.0.4-1) unstable; urgency=low

  * new upstream version (chunking everywhere, ncrename bugfix, ncks -m)

 -- Charlie Zender <zender@uci.edu>  Thu, 02 Sep 2010 20:34:38 -0700

nco (4.0.3-1) unstable; urgency=low

  * new upstream version (cf_date() bug, ncbo bug, configure tweaks)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Charlie Zender <zender@uci.edu>  Thu, 02 Sep 2010 18:05:48 -0700

nco (4.0.2-1) unstable; urgency=low

  * new upstream version (namespace, ncatted NUL, ncap2 1-d arrays)

 -- Charlie Zender <zender@uci.edu>  Sun, 27 Jun 2010 11:04:41 -0700

nco (4.0.1-1) unstable; urgency=low

  [ Charlie Zender ]
  * new upstream version (fix_rec_dmn, mk_rec_dmn, .ncrename)
  * debian/copyright
    - remove John Burkhardt
  * debian/control
    - add ${misc:Depends}

  [ Francesco Paolo Lovergine ]
  * Policy bumped to 3.8.4.
  * Debhelper level set to 7.
  * Added me as uploaders.
  * Removing top dir info file.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 26 Apr 2010 22:51:21 +0200

nco (4.0.0-1) unstable; urgency=low

  * new upstream version (fitting, calendar, bilinear interp)

 -- Charlie Zender <zender@uci.edu>  Tue, 05 Jan 2010 12:06:24 -0800

nco (3.9.9-1) unstable; urgency=low

  * new upstream version (chunking, NC_STRING, GSL stats/interp, rebasing)
  * debian/control
    - Standards-Version: 3.8.2
  * debian/copyright
    - includes everyone now
  * debian/compat
    - change from 4 to 5

 -- Charlie Zender <zender@uci.edu>  Tue, 14 Jul 2009 18:31:07 -0700

nco (3.9.8-1) unstable; urgency=low

  * new upstream version (DAP-netCDF, sort(), array(), GSL RNG)
  * debian/control
    - BR libnetcdf-dev
    - debhelper > 5
  * debian/rules
    - remove --disable-rpath

 -- Charlie Zender <zender@uci.edu>  Wed, 29 Apr 2009 13:28:07 -0700

nco (3.9.7-1) unstable; urgency=low

  * new upstream version (improves GSL builds, ncap2 threading)

 -- Charlie Zender <zender@uci.edu>  Wed, 18 Mar 2009 16:43:24 -0700

nco (3.9.6-1) UNRELEASED; urgency=low

  * new upstream version (fixes MSA bug, adds GSL)

 -- Charlie Zender <zender@uci.edu>  Thu, 22 Jan 2009 13:27:19 -0800

nco (3.9.5-1) UNRELEASED; urgency=low

  * new upstream version (MSA everywhere)

 -- Charlie Zender <zender@neige.ess.uci.edu>  Sun, 11 May 2008 17:39:52 +0200

nco (3.9.4-1) UNRELEASED; urgency=low

  * new upstream version (-3, -X, --msa_usr_rdr, ncap2 mask, WIN32)

 -- Charlie Zender <zender@uci.edu>  Mon, 03 Mar 2008 14:03:30 +0100

nco (3.9.3-1) UNRELEASED; urgency=low

  * new upstream version (SWAMP, ncecat -u, wget, ncap OpenMP, GCC 4.2)

 -- Charlie Zender <zender@uci.edu>  Sat, 08 Dec 2007 15:26:47 +0100

nco (3.9.2-1) UNRELEASED; urgency=low

  * new upstream version (GPL3, _FillValue, UDUnits2, ncap2 printing)

 -- Charlie Zender <zender@uci.edu>  Wed, 29 Aug 2007 09:01:52 -0700

nco (3.9.1-1) UNRELEASED; urgency=low

  * new upstream version (supports netCDF4/HDF deflation)

 -- Charlie Zender <zender@uci.edu>  Fri, 29 Jun 2007 11:46:16 -0700

nco (3.9.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/rules
    - fixed FTBFS if build twice in a row (Closes: #442685)
  * debian/doc-base
    - changed section
  * debian/watch
    - added
  * debian/control
    - added Homepage field

 -- Sandro Tosi <matrixhasu@gmail.com>  Sat, 19 Apr 2008 16:28:04 +0200

nco (3.9.0-1) unstable; urgency=low

  * new upstream version (includes netCDF4 atomic types)

 -- Charlie Zender <zender@uci.edu>  Tue, 22 May 2007 19:04:54 -0700

nco (3.2.0-1) unstable; urgency=low

  * new upstream version (includes rmssdn arithmetic bugfix)

 -- Charlie Zender <zender@uci.edu>  Thu, 19 Apr 2007 22:19:00 -0700

nco (3.1.9-1) unstable; urgency=low

  * new upstream version

 -- Charlie Zender <zender@uci.edu>  Sat, 10 Mar 2007 18:47:03 -0800

nco (3.1.8-2) UNRELEASED; urgency=low

  * Bump version for upload to Debian unstable

 -- Charlie Zender <zender@uci.edu>  Wed, 24 Jan 2007 10:03:48 -0800

nco (3.1.8-1) experimental; urgency=low

  * ncap2 methods work, nascent _FillValue support
  * Add psd.nco example for ncap2
  * Fix in.nc and tst path issues in make check
  * Change long description	
  * Remove unused make command in control
  * Change section from "math" to "science" in control and doc-base
  * Remove ncap_lex.c, ncap_yacc.[ch] from tarball
  * Remove pgiCC OpenMP threading on ncap2
  * Exclude all .cvsignore's
  * Replace 'unstable' with 'UNRELEASED' from 3.0.0-3.1.7
  * Change debian/nco.doc-base to debian/doc-base
  * Create non-native debian packages
  * Add @dircategory netCDF to nco.texi
  * Removed debian/docs, alphabetize control, less precise debhelper
    version, refine copyright history, remove debian/doc, de-comment
    debian/rules, 
  * Remove debian/[postinst,prerm, postrm]. These only contained
    instructions for handling *.info files. Rely on dh_installinit to
    automagically create these instructions.   
  * Include ncap2 executable and man page
  * Add package dependencies on antlr, libantlr-dev 
  * Kludge HTML documentation location in nco.doc-base


=== debian/control ===
Source: nco
Section: science
Priority: optional
Maintainer: Charlie Zender <zender@uci.edu>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Build-Depends: debhelper (>= 7), antlr, bison, flex, gsl-bin, libgsl0-dev, libantlr-dev, netcdf-bin, libnetcdf-dev, texinfo, libudunits2-0, libudunits2-dev
Standards-Version: 3.8.4
Homepage: http://nco.sourceforge.net/

Package: nco
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command-line operators to analyze netCDF files
 NCO is a suite of programs known as operators. The operators are stand-alone,
 command-line programs executable in a POSIX shell. Operators take one or more
 netCDF files as input, perform operations (e.g., averaging, hyperslabbing),
 and produce a netCDF output file. NCO was originally designed to manipulate and
 analyze climate data, though it works on any netCDF format datasets.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Purpose: debian/rules file for NCO
# Copyright (C) 1999--2002 by Brian Mays
# Copyright (C) 2003--2011 by Charlie Zender
# Usage:
# scp ~/nco/debian/rules virga.ess.uci.edu:nco/debian

# Sample debian/rules that uses debhelper
# GNU copyright 1997 to 1999 by Joey Hess

# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode
#export DH_VERBOSE=1

# Export this to make some magic below work
export DH_OPTIONS

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags := --build=$(DEB_BUILD_GNU_TYPE)
else
	confflags := --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

export CFLAGS := -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
# 20110114 Enable dap-netcdf netcdf4 udunits2 build options by default
# Allow them to be turned off by putting disable-XXX in DEB_BUILD_OPTIONS
ifneq (,$(findstring disable-dap-netcdf,$(DEB_BUILD_OPTIONS)))
	confflags += --disable-dap-netcdf
else
	confflags += --enable-dap-netcdf
endif
ifneq (,$(findstring disable-netcdf4,$(DEB_BUILD_OPTIONS)))
	confflags += --disable-netcdf4
else
	confflags += --enable-netcdf4
	CPPFLAGS += -DHAVE_NETCDF4_H
endif
ifneq (,$(findstring disable-udunits2,$(DEB_BUILD_OPTIONS)))
	confflags += --disable-udunits2
else
	confflags += --enable-udunits2
endif

# Make Debian-default netCDF directories override development netCDF installations in, e.g., /usr/local
# 20070721: This may inadvertently cause libtool to set set rpath
# In turn this generates linda warnings about hard-coded rpath
# Since their Debian packages exist, always enable GSL and ncap2
# Environment variables NETCDF*, defined in Zender's bashrc, often confuse Debian
# Debian requires that libraries are known by package-manager
# Thus environment variables that point, e.g., to /usr/local, are unhelpful
config.status: configure
	dh_testdir
	LD_LIBRARY_PATH='' LDFLAGS='' NETCDF_INC='/usr/include' NETCDF_LIB='/usr/lib' NETCDF_ROOT='/usr' NETCDF4_ROOT='/usr' \
	./configure $(confflags) \
		--prefix=/usr \
		--infodir=/usr/share/info \
		--libdir=/usr/lib/nco \
		--mandir=/usr/share/man \
		--enable-gsl \
		--enable-ncap2 \
		--disable-dap-opendap \
		--disable-nco_cplusplus \
		--disable-udunits \
		--disable-static

# Architecture 
build: build-arch

build-arch: build-arch-stamp
build-arch-stamp:  config.status
	$(MAKE) 
	cd doc && $(MAKE) html
	cd doc && $(MAKE) nco.info
# Documentation to distribute in future
#	cd doc && $(MAKE) nco.ps
#	cd doc && $(MAKE) nco.dvi

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp config-stamp
	[ ! -f Makefile ] || $(MAKE) distclean

	rm -f data/big.nc

	dh_clean

install: install-arch

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -a
	dh_installdirs -a
# Commands to install architecture part of package into debian/tmp
	$(MAKE) install DESTDIR=$(CURDIR)/debian/nco
	rm `find $(CURDIR)/debian -name '*.la'`
# NCO installs header files by default, which Debian does not want (yet)
	dh_install -a --exclude="*.h *.hh"

# Must not depend on anything 
# This is to be called by binary-arch/binary-multi in another 'make' thread
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs doc/ChangeLog
	dh_installdocs
	install -d debian/nco/usr/share/doc/nco/html
	install -m 644 doc/nco.html/*.html debian/nco/usr/share/doc/nco/html
	rm -f debian/nco/usr/share/info/dir
	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target
binary-indep: build install

# Build architecture dependant packages using the common target
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install-arch

## nco 4.0.8

=== bld/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Header: /cvsroot/nco/nco/bld/Makefile,v 1.573 2011/02/17 21:21:46 zender Exp $ -*-makefile-*-
+# $Header: /cvsroot/nco/nco/bld/Makefile,v 1.584 2011/04/27 02:50:25 zender Exp $ -*-makefile-*-
 
 # Purpose: GNU Makefile for NCO module nco
 # Requires GNU Make---AT&T Make chokes on GNU syntax
@@ -61,9 +61,9 @@
 # cd ${HOME}/nco/bld;ANTLR=/sopt/pgf90_pgcc/bin/antlr ANTLR_ROOT=/sopt/pgf90_pgcc CNK=N SZ_LIB=/sopt/lib UDUNITS_INC=/sopt/include UDUNITS_LIB=/sopt/lib make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N SZ=Y UDUNITS2=N allinone;cd - # greenplanet pgi
 # cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=Y allinone;cd - # pbs
 # cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=Y allinone;cd - # grele
-# cd ${HOME}/nco/bld;make OMP=N DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=N USR_TKN='-DNCO_GSL_MINOR_VERSION=4' allinone;cd - # sand, tephra
+# cd ${HOME}/nco/bld;make NETCDF4=N all ncap2;cd - # tephra
 # cd ${HOME}/nco/bld;make OMP=Y DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=N allinone;cd - # silt, clay
-# cd ${HOME}/nco/bld;NETCDF_INC='/usr/include/netcdf-3' NETCDF_LIB='/usr/lib64' make GSL=N OMP=N DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS=N  allinone;cd - # snow
+# cd ${HOME}/nco/bld;NETCDF_INC='/usr/include/netcdf-3' NETCDF_LIB='/usr/lib64' make GSL=N OMP=N DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS=N allinone;cd - # snow
 # cd ${HOME}/nco/bld;make OMP=N DAP_OPENDAP=Y OPTS=D NETCDF4=N UDUNITS2=N USR_TKN='-DNEED_NC_INQ_FORMAT' allinone;cd - # snow w/OPeNDAP
 # cd ${HOME}/nco/bld;make OPTS=D USR_TKN='-DNEED_NC_INQ_FORMAT' allinone;cd -
 # 64-bit ABI on UCI MPC:
@@ -71,13 +71,16 @@
 # 64-bit ABI on UCI IPCC:
 # cd ${HOME}/nco/bld;env ANTLR='/usr/local/pgi/bin/antlr' ANTLR_ROOT='/usr/local/pgi' make --jobs=1 ABI=64 allinone;cd -
 # 64-bit ABI netCDF3 on NCAR AIX systems (bluefire):
-# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' NETCDF_LIB='/usr/local/lib64/r4i4' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 DAP_OPENDAP=N OPTS=D allinone ABI=64;cd -
+# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' NETCDF_LIB='/usr/local/lib64/r4i4' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=N allinone ABI=64;cd -
 # 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
-# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' CURL_LIB='/contrib/curl/lib' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' HDF5_ROOT='/contrib/hdf5-1.8.4-patch1_sequential' NETCDF_ROOT='/contrib/netcdf-4.1.1_sequential' SZ_LIB='/contrib/szip/lib' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 NETCDF4=Y OPTS=D SZ=Y allinone ABI=64;cd -
-# cd ~/bin/AIX;/usr/local/bin/tar cvzf ~/nco-4.0.6.aix53.tar.gz nc*;scp ~/nco-4.0.6.aix53.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
+# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' CURL_LIB='/contrib/curl/7.21.2/lib' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' HDF5_ROOT='/contrib/hdf5-1.8.6_seq' LDFLAGS='-lnetcdf -lhdf5_hl -lhdf5 -lz' NETCDF_ROOT='/contrib/netcdf-4.1.2_seq' SZ_LIB='/contrib/szip/lib' UDUNITS_LIB='/contrib/zlib/lib' make --jobs=1 OPTS=D SZ=Y allinone ABI=64;cd -
+# 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
+# cd ~/bin/AIX;/usr/local/bin/tar cvzf ~/nco-4.0.8.aix53.tar.gz nc*;scp ~/nco-4.0.8.aix53.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
+# netCDF4 on NCAR Linux cluster systems (mirage):
+# cd ~/nco/bld;make OPTS=D allinone;cd -
 # Cygwin on Windows Vista systems:
 # cd ~/nco/bld;ANTLR='antlr' make --jobs=1 GSL=Y OPTS=D NETCDF4=Y UDUNITS2=Y allinone;cd -
-# cd ~/bin/WIN32;tar cvzf ~/nco-4.0.6.win32.cygwin.tar.gz nc* ; scp ~/nco-4.0.6.win32.cygwin.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
+# cd ~/bin/WIN32;tar cvzf ~/nco-4.0.8.win32.cygwin.tar.gz nc* ; scp ~/nco-4.0.8.win32.cygwin.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
 
 # Top-level tokens defining directory structure
 # These tokens may be over-ridden by environment variables or when invoking make, e.g., make DAP_OPENDAP=Y
@@ -299,4 +302,3 @@
 # This tests compile, link, execution of MPI mpnc*.c code without using any MPI calls
  MPI := Y
 endif # !MPI_FAKE
-ifdef MPI_PRC

=== debian/changelog ===
nco (4.0.8-1) unstable; urgency=low

  * New upstream release.
  * Moved to DebianGis maintainership, as asked by Charlie Zender.
  * Repository set onto alioth git, with Vcs-* usual settings.
  * Added makeinfo as build-dep for generating html docs. 

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 29 Nov 2011 12:49:29 +0100

## nco 4.0.9

=== bld/Makefile ===
--- 
+++ 
@@ -1,16 +1,16 @@
-# $Header: /cvsroot/nco/nco/bld/Makefile,v 1.584 2011/04/27 02:50:25 zender Exp $ -*-makefile-*-
+# $Header: /cvsroot/nco/nco/bld/Makefile,v 1.590 2012/02/02 18:13:19 zender Exp $ -*-makefile-*-
 
 # Purpose: GNU Makefile for NCO module nco
 # Requires GNU Make---AT&T Make chokes on GNU syntax
 
-# Copyright (C) 1994--2011 Charlie Zender
+# Copyright (C) 1994--2012 Charlie Zender
 # License: GNU General Public License (GPL) Version 3
 # See http://www.gnu.org/copyleft/gpl.html for full license text
 
 # Quickie test copies:
+# scp ~/nco/bld/Makefile bluefire.ucar.edu:nco/bld
 # scp ~/nco/bld/Makefile dust.ess.uci.edu:nco/bld
 # scp ~/nco/bld/Makefile gplogin2.ps.uci.edu:nco/bld
-# scp ~/nco/bld/Makefile soot.ess.uci.edu:nco/bld
 
 # Development machines default configuration:
 # netCDF4, UDUnits2: ashes, elnino, virga, neige
@@ -35,7 +35,7 @@
 # cd ~/nco/bld;make dir all; cd -    # Create target directories then build
 # cd ~/nco/bld;make dbg;cd -         # Print make diagnostics
 # cd ~/nco/bld;make DAP_OPENDAP=Y;cd - # DAP support via OPeNDAP
-# cd ~/nco/bld;make GSL=Y;cd -	     # GSL support
+# cd ~/nco/bld;make GSL=Y;cd -	     #a GSL support
 # cd ~/nco/bld;make lib_cln;cd -     # Clean libraries
 # cd ~/nco/bld;make MPI=Y;cd -       # MPI support
 # cd ~/nco/bld;make MPI_FAKE=Y;cd -  # Spoof MPI support
@@ -74,13 +74,15 @@
 # cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' NETCDF_LIB='/usr/local/lib64/r4i4' UDUNITS_INC='/contrib/udunits-1.12.9/include' UDUNITS_LIB='/contrib/udunits-1.12.9/lib' make --jobs=1 DAP_OPENDAP=N OPTS=D NETCDF4=N UDUNITS2=N allinone ABI=64;cd -
 # 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
 # cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' CURL_LIB='/contrib/curl/7.21.2/lib' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' HDF5_ROOT='/contrib/hdf5-1.8.6_seq' LDFLAGS='-lnetcdf -lhdf5_hl -lhdf5 -lz' NETCDF_ROOT='/contrib/netcdf-4.1.2_seq' SZ_LIB='/contrib/szip/lib' UDUNITS_LIB='/contrib/zlib/lib' make --jobs=1 OPTS=D SZ=Y allinone ABI=64;cd -
+# Untested:
+# cd ~/nco/bld;ANTLR='/contrib/antlr-2.7.7/bin/antlr' ANTLR_ROOT='/contrib/antlr-2.7.7' CURL_LIB='/contrib/curl/7.21.2/lib' GSL_INC='/contrib/gsl-1.12/include' GSL_LIB='/contrib/gsl-1.12/lib' HDF5_ROOT='/contrib/hdf5-1.8.7_seq' LDFLAGS='-lnetcdf -lhdf5_hl -lhdf5 -lz' NETCDF_ROOT='/contrib/netcdf/4.1.3_seq' SZ_LIB='/contrib/szip/lib' UDUNITS_LIB='/contrib/zlib/lib' make --jobs=1 OPTS=D SZ=Y allinone ABI=64;cd -
 # 64-bit ABI netCDF4 on NCAR AIX systems (bluefire):
-# cd ~/bin/AIX;/usr/local/bin/tar cvzf ~/nco-4.0.8.aix53.tar.gz nc*;scp ~/nco-4.0.8.aix53.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
+# cd ~/bin/AIX;/usr/local/bin/tar cvzf ~/nco-4.0.9.aix53.tar.gz nc*;scp ~/nco-4.0.9.aix53.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
 # netCDF4 on NCAR Linux cluster systems (mirage):
 # cd ~/nco/bld;make OPTS=D allinone;cd -
 # Cygwin on Windows Vista systems:
 # cd ~/nco/bld;ANTLR='antlr' make --jobs=1 GSL=Y OPTS=D NETCDF4=Y UDUNITS2=Y allinone;cd -
-# cd ~/bin/WIN32;tar cvzf ~/nco-4.0.8.win32.cygwin.tar.gz nc* ; scp ~/nco-4.0.8.win32.cygwin.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
+# cd ~/bin/WIN32;tar cvzf ~/nco-4.0.9.win32.cygwin.tar.gz nc* ; scp ~/nco-4.0.9.win32.cygwin.tar.gz zender,nco@web.sf.net:/home/project-web/nco/htdocs/src
 
 # Top-level tokens defining directory structure
 # These tokens may be over-ridden by environment variables or when invoking make, e.g., make DAP_OPENDAP=Y
@@ -290,15 +292,3 @@
 
 # Internationalize NCO with i18n features
 ifeq (${I18N},Y)
- MY_SHR_DIR := ${HOME}/share
- MY_ES_DIR := ${MY_SHR_DIR}/locale/es/LC_MESSAGES
- MY_FR_DIR := ${MY_SHR_DIR}/locale/fr/LC_MESSAGES
-endif
-
-# Message Passing Interface (MPI)
-ifeq (${MPI_FAKE},Y)
-# MPI_FAKE instructs make to compile mpnc*.c operators without defining ENABLE_MPI
-# Resulting executables use UP or SMP code not MPI code
-# This tests compile, link, execution of MPI mpnc*.c code without using any MPI calls
- MPI := Y
-endif # !MPI_FAKE

=== debian/changelog ===
nco (4.0.9-1) unstable; urgency=low

  * New upstream release.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sun, 19 Feb 2012 18:27:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,14 @@
 Source: nco
 Section: science
 Priority: optional
-Maintainer: Charlie Zender <zender@uci.edu>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
-Build-Depends: debhelper (>= 7), antlr, bison, flex, gsl-bin, libgsl0-dev, libantlr-dev, netcdf-bin, libnetcdf-dev, texinfo, libudunits2-0, libudunits2-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 8), antlr, bison, flex, gsl-bin, libgsl0-dev, 
+ libantlr-dev, netcdf-bin, libnetcdf-dev, texinfo, libudunits2-0, libudunits2-dev, libdap-dev
+Standards-Version: 3.9.2
 Homepage: http://nco.sourceforge.net/
+Vcs-Browser: http://git.debian.org/?p=pkg-grass/nco.git
+Vcs-Git: git://git.debian.org/git/pkg-grass/nco.git
 
 Package: nco
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -71,18 +71,21 @@
 		--mandir=/usr/share/man \
 		--enable-gsl \
 		--enable-ncap2 \
-		--disable-dap-opendap \
 		--disable-nco_cplusplus \
 		--disable-udunits \
 		--disable-static
 
 # Architecture 
-build: build-arch
+build: build-arch build-indep
+
+build-indep: build-indep-stamp
+build-indep-stamp:
+	# do nothing
 
 build-arch: build-arch-stamp
 build-arch-stamp:  config.status
 	$(MAKE) 
-	cd doc && $(MAKE) html
+	cd doc && $(MAKE) clean && $(MAKE) html
 	cd doc && $(MAKE) nco.info
 # Documentation to distribute in future
 #	cd doc && $(MAKE) nco.ps
@@ -93,9 +96,7 @@
 	dh_testroot
 	rm -f build-arch-stamp build-indep-stamp config-stamp
 	[ ! -f Makefile ] || $(MAKE) distclean
-
 	rm -f data/big.nc
-
 	dh_clean
 
 install: install-arch
@@ -133,6 +134,7 @@
 	dh_md5sums
 	dh_builddeb
 
+
 # Build architecture independant packages using the common target
 binary-indep: build install
